<template>
  <component :is="currentTemplate" :content="currentContent" :error="currentError"></component>
</template>

<script lang="ts">
  import Vue from 'vue'
  import Component from 'vue-class-component'
  import { VueConstructor } from 'vue/types/vue'
  import { Content } from '../content/Content'
  import { ContentNotFoundError } from '../errors/ContentNotFoundError'
  import { TemplateNotFoundError } from '../errors/TemplateNotFoundError'
  import Template from './Template.vue'

  Component.registerHooks([
    'beforeRouteEnter',
  ])

  @Component({})
  export default class RouteManager extends Vue {
    currentTemplate: VueConstructor<Template> | null = null
    currentContent: Content | null = null
    currentError: Error | null = null

    beforeRouteEnter(to, from, next) {
      next(vue => {
        try {
          let content = vue.$kaiba.content.getByURI(to.path)
          if (!content) throw new ContentNotFoundError(to.path)
          
          let template = vue.$kaiba.theme.getTemplate(content.contentType)
          if (!template) throw new TemplateNotFoundError(content.contentType)
          
          vue.currentTemplate = template
          vue.currentContent = content
        }

        catch (e) {
          vue.currentTemplate = vue.$kaiba.theme.errorTemplate
          vue.currentError = e
        }
      })
    }
  }
</script>

